-- $Id$
--
-- Copyright (c) 2007 Fabian "firsm" Hirschmann <fhirschmann@gmail.com>

-- Permission is hereby granted, free of charge, to any person obtaining a copy
-- of this software and associated documentation files (the "Software"), to deal
-- in the Software without restriction, including without limitation the rights
-- to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is
-- furnished to do so, subject to the following conditions:

-- The above copyright notice and this permission notice shall be included in
-- all copies or substantial portions of the Software.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
-- IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
-- FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
-- AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
-- LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
-- OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
-- THE SOFTWARE.

local forum = {}
forum.list = iup.list{
    "General",
    "Bugs",
    "Suggestions",
    "Windows",
    "MacOS X",
    "Linux",
    "Role Playing",
    "Off-Topic",
    "Community Projects",
    expand = "HORIZONTAL",
    dropdown = "YES"
}

forum.threads = iup.list{"No forum selected.", expand="YES"}

-- define
forum = forum or {}
if not forum then 
  declare (forum)
end

forum.ui = forum.ui or {}
if not forum.ui then
  declare (forum.ui)
end
-- end define

forum.VISIBLE = false


local fetchthreads = iup.stationbutton{title="View"}
local dofetchthreads = HTTP.new()
dofetchthreads.version = "1.0"
local function onfetchthreads (resp)
    resp.body.grep('messageText')
    local col = 0
    local row = 0
    
    local threadtbl = {}
    
    for line in resp.body.get():gmatch("[^\r\n]+") do
        if line:match('<td class=messageText1>') then
            row = row+1
            threadtbl[row] = {}
            col = 1
        else
            col = col+1
        end
        
        if col == 1 then -- title
            threadtbl[row].num, threadtbl[row].title = line:match('.*<a href="/x/msgboard/%d/(%d*)">(.-)</a>')
        elseif col == 2 then -- replies
            threadtbl[row].replies = line:match('<td class=messageTextSmall align=center>(%d*)</td>')
        elseif col == 3 then -- author
            threadtbl[row].author = line:match('<td class=messageTextSmall>(.-)</td>')
            if threadtbl[row].author:match('<font color=#ff4040><b>') then
                threadtbl[row].author = threadtbl[row].author:match('<font color=#ff4040><b>(.-)</b></font>')
            end
        elseif col == 4 then -- last post
            threadtbl[row].lastp = line:match('<td class=messageTextSmall>(.-)<br>')
        end
        
        
        --local num, title
        --num, title = line:match('.*<a href="/x/msgboard/%d/(%d*)">(.-)</a>')
        --forum.threads[i] = title
    end
    local i = 0
    for x, y in pairs(threadtbl) do
        i = i+1
        forum.threads[i] = y.title..' ['..y.replies..', '..y.author..', '..y.lastp..']'
    end
    forum.threads[i+1] = nil
end
function fetchthreads:action()
    dofetchthreads.urlopen('http://vendetta-online.com/x/msgboard/'..tostring(forum.list.value), onfetchthreads)
end

-- display box
forum.ui.MAIN = iup.dialog {
    iup.pdarootframe {
        iup.vbox{
            iup.hbox{
                forum.list,
                fetchthreads,
                gap=5,
                alignment="ACENTER"
            },
            forum.threads,
            gap=4,
            iup.fill{},
        },
    };
    TITLE = 'forum ',
    BORDER = 'YES',
    TOPMOST = 'YES',
    RESIZE = 'NO',
    MAXBOX = 'NO',
    MINBOX = 'NO',
    MODAL = 'YES',
    FULLSCREEN = 'NO',
    EXPAND = 'NO',
    SIZE = 'HALFxHALF',
    DEFAULTESC = forum.HIDE,
} -- end dialog box
-- end display box


-- functions
function forum.HIDE()
  --close the app
  forum.visible = false
  forum.ui.MAIN:hide()
end -- forum.HIDE()


function forum.SHOW()
  --open the app
  forum.VISIBLE = true
  forum.ui.MAIN:show()
end  --forum.SHOW()


function forum.commands(data,args)
  if args then
  else
    forum.ui.MAIN:show()
  end
end -- forum.commands()


function forum.ui.MAIN:k_any(char)
  local command = gkinterface.GetCommandForKeyboardBind(char)
  if command == 'forum' then
    forum.ui.MAIN:hide()
    return iup.IGNORE
  end
  return iup.CONTINUE
end -- forum.ui.MAIN:k_any()


-- end functions


  
--register
RegisterUserCommand('forum',forum.commands)
